#include <stdbool.h>
#include <stdlib.h>

// Warteschlange fr int

#define maxNumElements 8 // wrde man "klassisch" gro schreiben: MAX_NUM_ELEMENTS
struct Queue
{
  int q[maxNumElements];
  int in;
  int out;
};
typedef struct Queue Queue;

Queue* createQueue(void)
{
  Queue* p = (Queue*)malloc(sizeof(Queue));
  p->in = 0;
  p->out = 0;
  return p;
}

void freeQueue(Queue *p)
{
  free(p);
}

void enqueue(Queue* q, int x)
{
  q->q[q->in] = x;
  q->in--;
  if(q->in < 0)
  {
    q->in = maxNumElements - 1;
  }
}

int dequeue(Queue* q)
{
  int x = q->q[q->out];
  q->out--;
  if(q->out < 0)
  {
    q->out = maxNumElements - 1;
  }  
  return x;
}

bool hasNext(Queue* q)
{
  return q->in != q->out;
}

int main( void )
{
  Queue *pw = createQueue();
  Queue *pv = createQueue();
  enqueue(pw, 1);
  enqueue(pw, 2);
  enqueue(pw, 3);
  enqueue(pv, 1);
  enqueue(pw, 4);
  int a = 42;
  while(hasNext(pw))
  {
    a = dequeue(pw);
  }
  while(hasNext(pv))
  {
    a = dequeue(pv);
  }
  
  freeQueue(pv);
  freeQueue(pw);
  
  return 0;
}
